<?php
//TITLE=Dynamic C++ expressions

$title = 'Dynamic C++ expressions';
$progname = 'dynbisq';

$text = array(
   '1. Contents' => "

", '1.1. Dynamic expressions template' => "

Allows you to write code like this:<pre>
    dyn&lt;int&gt; a,b,c;
    
    a = 5;
    b = 2;
    c = a+b;
    b = 4;
    cout &lt;&lt; c;
</pre>
And get 9 as result instead of 7.<br>
(Ok, actually <code>cout &lt;&lt, c</code> does not current work
 for safety reasons. <code>cout &lt;&lt; c.value()</code> does.)

", '1.1. Dynamic classes' => "

The archive contains also a completely different thing: dynamically
linked C++ classes and a shared object pool which allows you to
pick up inherited objects by name. Demonstration of the latter:<pre>
proteus:~/src/dyn$ ./dyntest
Loading lib './libmama.so'
Loading sym 'Mama'
Loading sym 'Baby'
Loading lib './libpapa.so'
Loading sym 'Papa'

Testing Papa.
 Papa comes.
 Papa waves.
 Papa goes.
Unloading sym 'Papa'
Unloading lib './libpapa.so' (it is no longer in use)

Getting 'Baby'
  Baby comes.
  Baby waves its hand happily.
  Baby goes.
Unloading sym 'Baby'

Getting 'Mama'
 Mama comes.
 Mama waves.
 Mama goes.
Unloading sym 'Mama'
Unloading sym 'Mama'
Unloading sym 'Baby'
Unloading lib './libmama.so' (it is no longer in use)</pre>

(Papa, Mama and Baby are derived types from Thing-class,
 which is the only thing the dyntest executable knows of.)
<p>
This dynlib thing has been designed to be used fairly easily
without much needed changes to get it working. Here's the papa.cc
as an example (<code>BASETYPE_THING</code> is defined in thing.hh,
and describes the base type of the class for the loader):

", '1.1.1. papa.cc (example of a dynamic class)' => "

<pre>#include &lt;cstdio&gt;
#include \"thing.hh\"

class Papa : public Thing
{
public:
    Papa() { std::printf(\" Papa comes.\\n\"); }
    virtual ~Papa() { std::printf(\" Papa goes.\\n\"); }
    virtual void Wave() { std::printf(\" Papa waves.\\n\"); }
};

#include \"dynlib.hh\"

static void *newpapa(void) { return new Papa; }

dyncontent contents[] =
{
    { BASETYPE_THING, \"Papa\", newpapa },
    { 0, NULL, NULL }
};</pre>

", '1. Copying' => "

This code has been written by Joel Yliluoma, a.k.a.
<a href=\"http://bisqwit.iki.fi/\">Bisqwit</a>,<br>
and is distributed under the following terms:<br>
<blockquote><code>".
str_replace("\n",'<br>',htmlspecialchars(fread(fopen('/WWW/TINYFREELICENSE','r'),filesize('/WWW/TINYFREELICENSE')))).
"</code></blockquote>

");
include '/WWW/progdesc.php';
